
//	Copyright 2010 Ohtan's Design Corporation

//	*     * okiaGlcdlib
//	**    *
//	* *   *
//	*  *  *
//	*   * *
//	*    **
//	*     *

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	004 2010.08.24
//	EC\Vtg\ɂi\[`̊Sj
// ---------------------------------------------------------------------------
//	003 2010.08.20
//	E\
// ---------------------------------------------------------------------------
//	002 2010.08.20
//	EI/O_̏C
// ---------------------------------------------------------------------------
//	001 2010.06.26
//	EVK쐬
//  Crated by A.Ohta
// ===========================================================================

// ***************************************************************************
//		mLA5110LCD쓮pCu[
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************

#include	<htc.h>
#include	"nokiaGlcdlib.h"											//  LCD
#include	"device.h"													//

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

#define	INIT_PORTC_DIR		0b00000000 									//	|[go͕

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************

/* uhPav */
unsigned char const font_hPa[] = 
{
	0b11111110,
	0b00010000,
	0b00001000,
	0b11111000,
	0b00000000,
	0b11111110,
	0b00010010,
	0b00010010,
	0b00001100,
	0b01000000,
	0b10101000,
	0b10101000,
	0b01110000,
};

/*  */
unsigned char const font_num[10][5]=
{
	{ /* 0 */
	0b01111100,
	0b10000010,
	0b10000010,
	0b10000010,
	0b01111100,
	},

	{ /* 1 */
	0b00000000,
	0b00000100,
	0b11111110,
	0b00000000,
	0b00000000,
	},

	{ /* 2 */
	0b11000100,
	0b10100010,
	0b10010010,
	0b10010010,
	0b10011100,
	},

	{ /* 3 */
	0b01000100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01111100,
	},

	{ /* 4 */
	0b00011000,
	0b00010100,
	0b00010010,
	0b11111110,
	0b00010000,
	},

	{ /* 5 */
	0b01011110,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01100010,
	},

	{ /* 6 */
	0b01111100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01100100,
	},

	{ /* 7 */
	0b00000010,
	0b00000010,
	0b11100010,
	0b00010010,
	0b00001110,
	},

	{ /* 8 */
	0b01101100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01101100,
	},

	{ /* 9 */
	0b00001100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01111100,
	},
};


/* uv */
unsigned char const font_do[] = 
{
	0b00000100,
	0b00001010,
	0b00000100,
	0b00000000,
	0b01111100,
	0b10000010,
	0b10000010,
	0b10000010,
	0b01000100,
};

/* u{v */
unsigned char const font_plus[] =
{
	0b00010000,
	0b00010000,
	0b01111100,
	0b00010000,
	0b00010000,

};

/* u|v */
unsigned char const font_minus[] =
{
	0b00010000,
	0b00010000,
	0b00010000,
	0b00010000,
	0b00010000,
};

/* u.v */
unsigned char const font_period[] =
{
	0b00000000,
	0b11000000,
	0b11000000,
	0b00000000,
	0b00000000,
};


/* u%v */
unsigned char const font_percent[] =
{
	0b01000010,
	0b00100101,
	0b01010010,
	0b10101000,
	0b01000100,
};

//============================================================================
//	mLA5110LCD۰Ư PCD8544 ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void LCD_init()
{
	TRISC  = INIT_PORTC_DIR;											//  PORTCo͕WX^ ύX
	PORTC  = 0b00000001;												//  PORTC ݒ

//  LCDݒ

	DevSigPutLcdRES_L();												//  LCD Zbgw	֐Ăяo
	__delay_us(10);														//  LCD Zbgێ
	DevSigPutLcdRES_H();												//  LCD Zbg	֐Ăяo

	DevSigPutLcdDC_L();													//	֐Ăяoă|[gkB̏o͒[q͕⏞
	SPI_SCE = 0;														//  LCD `bvCl[u
	SPI_CLK = 0;														//  ݒ

	SPI_tx_byte(0b00100000 | 1, 0);										//  H = 1
	SPI_tx_byte(0b00000100 | 1, 0);										//  TC = 1 (0-3)
	SPI_tx_byte(0b00010000 | 3, 0);										//  Bais = 3 (0-7)
	SPI_tx_byte(0b10000000 | 68, 0);									//  Vop = 68 (0-127) RgXgݒ
	SPI_tx_byte(0b00100000 | 0, 0);										//  H = 0, Horizontal addressing
	SPI_tx_byte(0b00001000 | 4, 0);										//  Display Mode Normal = 4
	SPI_tx_byte(0b01000000 | 0, 0);										//  Set Y = 0 (0-5)
	SPI_tx_byte(0b10000000 | 0, 0);										//  Set X = 0 (0-83)

}


//============================================================================
//	LCD݈̏ʒu@wAx@ɐݒ肷
//----------------------------------------------------------------------------
//	́F	unsigned char x,unsigned char y
//	óF	
//----------------------------------------------------------------------------
//	lF	0 <= x <= 83, 0 <= y <= 5
//  		 y ͉Eォ牺@LSBŏl̂WrbgP
//  		mLALCD̃Ot́Aオ_B
//============================================================================
void LCD_locate(unsigned char x,unsigned char y)
{
	SPI_tx_byte(0b01000000 | y, 0);										//  Set Y = y
	SPI_tx_byte(0b10000000 | x, 0);										//  Set X = x
}

//============================================================================
//	݂݈̏ʒuwoCg̃f[^
//----------------------------------------------------------------------------
//	́F	unsigned char *datap,int len
//	óF	
//----------------------------------------------------------------------------
//	lF	̃R}hlen̉񐔕xʒu𑝂₵Ȃ牡ւPoNw肳ꂽoCgf[^
//============================================================================
void LCD_set_data(unsigned char *datap,int len)
{
	for (;len>0;len--)
		SPI_tx_byte(*(datap++), 1);
}

//============================================================================
//	݂݈̏ʒuwoCg̕\NA
//----------------------------------------------------------------------------
//	́F	unsigned int len
//	óF	
//----------------------------------------------------------------------------
//	lF	̃R}hlen̉񐔕xʒu𑝂₵Ȃ牡ւPoNNA
//============================================================================
void LCD_clear(unsigned int len)
{
	for (;len>0;len--)
		SPI_tx_byte(0, 1);
}

//============================================================================
//	Data/Command@w肵āALCDɂPoCg𑗐M
//----------------------------------------------------------------------------
//	́F	unsigned char d,int dc
//	óF	
//----------------------------------------------------------------------------
//	lF	dc = 0 : Command, dc = 1 : Data
//============================================================================
void SPI_tx_byte(unsigned char d,int dc)
{
	char Loop;
 

	SPI_SCE = 0;

	if (dc) {
		DevSigPutLcdDC_H();
	}
	else {
		DevSigPutLcdDC_L();
	}

	for (Loop=0;Loop<8;Loop++){
		SPI_DATA = 0;
		if ((d & (unsigned char)0x80) != 0){
			SPI_DATA = 1;
		}
		__delay_us(3);
		SPI_CLK = 1;
		d <<= 1;
		__delay_us(6);
		SPI_CLK = 0;
	}
	SPI_SCE = 1;
}

//============================================================================
//	Pʂňʒuw肵Đ̐\
//----------------------------------------------------------------------------
//	́F	int n: int col, int y_bank
//	óF	
//----------------------------------------------------------------------------
//	lF	col :
//============================================================================
void print_num(int n, int col, int y_bank)
{
	int r;
	unsigned char *pc;

	do {
		r = n % 10;														//  1ԉ̌̒lvZ
		n = n / 10;
		LCD_locate(col*6, y_bank);										//  \ʒuvZ
		pc = (unsigned char *)(font_num[r]);
		LCD_set_data(pc, 5);											//  1ԉ̌̒lɑΉ镶\
		--col;
	} while (n > 0);													//  SĂ̌\܂ŌJԂ
}

//============================================================================
//	C̒P hPa \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_unithps()
{
	int col;
	int r;
	unsigned char *pc;

	/* uhPav\ */
	LCD_locate(15, 1);
	pc = (unsigned char *)font_hPa;
	LCD_set_data(pc, 13);
}

//============================================================================
//	x̒P  \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_unitdeg()
{
	int col;
	int r;
	unsigned char *pc;

	/* uv\ */
	LCD_locate(20, 3);
	pc = (unsigned char *)font_do;
	LCD_set_data(pc, 9);
}

//============================================================================
//	Ύx̒P % \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_percent()
{
	int col;
	int r;
	unsigned char *pc;

	/* u%v\ */
	LCD_locate(24, 5);
	pc = (unsigned char *)font_percent;
	LCD_set_data(pc, 5);
}

//============================================================================
//	mLA5110LCD́@(x, y)sNZWɓ_`悷B
//----------------------------------------------------------------------------
//	́F	int x, int y
//	óF	
//----------------------------------------------------------------------------
//	lF	ÝAŏA㑤őimLALCDY𔽓]ĕ\jB
//			0 <= x <= 83 , 0 <= y <= 47 őnAŏl𒴂Ăꍇ́A͈͓ 
//			NvB 
//============================================================================
void draw_point(int x, int y)
{
	int bank_y;
	unsigned char pat_y;

	if (y < 0) {
		bank_y = LCD_MAX_BANK;											//  Y̒lȂ΁AOt̍ŏlɃNvăvbgB
		pat_y = 0b10000000;												//  LCD̍ő呤ij𐔒l̍ŏƂ邽߁AMSBŏlB
	} else if (y > LCD_MAX_Y) {
		bank_y = 0;														//  Y̒lől𒴂ĂȂ΁AOőlɃNvăvbgB
		pat_y = 0b00000001;												//  LCD̍ŏi㑤j𐔒l̍őƂ邽߁ALSBőlB
	} else {
		bank_y = LCD_MAX_BANK - (y / 8);								//  y]ʒuɃoN
		pat_y = 0b10000000 >> (y % 8);									//  oNMSBŏlƂ邱ƂY\0ƂȂ
	}
	LCD_locate(x, bank_y);												//  xʒũoN
	LCD_set_data(&pat_y, 1);											//  oN8rbgp^[

}

//============================================================================
//	(x, y)sNZWɋC`
//----------------------------------------------------------------------------
//	́F	int x, int prsy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Prespoint(int x, int prsy)
{

	int bank_prsy;
	unsigned char pat_prsy;
															//  OtԂ̏A͈͓ɒlNvB

	if (prsy < 32 ) {										//  ClCOtԂ̍ŏ͈͂H
		bank_prsy = 1;
		pat_prsy = 0b10000000;
	}
	else if (prsy > 47 ) {									//  ClCOtԂ̍ő͈͂オH
		bank_prsy = 0;
		pat_prsy = 0b00000001;
	}
	else {
		bank_prsy = LCD_MAX_BANK - (prsy / 8);				//  \oNvZ
		pat_prsy = 0b10000000 >> (prsy % 8);				//  oÑrbgʒuvZ
	}
	LCD_locate(x, bank_prsy);								//  xʒuŃoN(C)
	LCD_set_data(&pat_prsy, 1);								//  oN֋C8rbgp^[
}

//============================================================================
//	(x, y)sNZWɋC`
//----------------------------------------------------------------------------
//	́F	int x, int degy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Temppoint(int x, int tempy)
{

	int bank_tempy;
	unsigned char pat_tempy;
															//  OtԂ̏A͈͓ɒlNvB

	if (tempy < 16 ) {										//  ClCOtԂ̍ŏ͈͂H
		bank_tempy = 3;
		pat_tempy = 0b10000000;
	}
	else if (tempy > 31 ) {									// @ClCOtԂ̍ő͈͂オH
		bank_tempy = 2;
		pat_tempy = 0b00000001;
	}
	else {
		bank_tempy = LCD_MAX_BANK - (tempy / 8);			//  \oNvZ
		pat_tempy = 0b10000000 >> (tempy % 8);				//  oÑrbgʒuvZ
	}
	LCD_locate(x, bank_tempy);								//  xʒuŃoN(C)
	LCD_set_data(&pat_tempy, 1);							//  oN֋C8rbgp^[
}

//============================================================================
//	(x, y)sNZWɎx`
//----------------------------------------------------------------------------
//	́F	int x, int rhy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Rhumpoint(int x, int rhy)
{

	int bank_rhy;
	unsigned char pat_rhy;
															//  OtԂ̏A͈͓ɒlNvB

	if (rhy < 0 ) {											//  xlxOtԂ̍ŏ͈͂H
		bank_rhy = 5;
		pat_rhy = 0b10000000;
	}
	else if (rhy > 15 ) {									// @xlxOtԂ̍ő͈͂オH
		bank_rhy = 4;
		pat_rhy = 0b00000001;
	}
	else {
		bank_rhy = LCD_MAX_BANK - (rhy / 8);				//  \oNvZ
		pat_rhy = 0b10000000 >> (rhy % 8);					//  oÑrbgʒuvZ

	}
		LCD_locate(x, bank_rhy);							//  xʒuŃoN(x)
		LCD_set_data(&pat_rhy, 1);							//  oNx8rbgp^[
}

//============================================================================
//	OtY\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_Yaxis()
{
	int	x, y;
	unsigned char c;

	c = 0b10101010;
	x = LCD_MAX_X - GRAPH_HIST_MAX;

	//* c\

	for (y = 0; y < 6; y++) {
		LCD_locate(x, y);
		LCD_set_data(&c, 1);
	}

	//* Y݂̍\
	for (y = 0; y <= LCD_MAX_Y; y += 16) {
		draw_point(x-1, y);
	}
}

//============================================================================
//	Plot X ʒűCOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Presclear(int plotx)
{
	int	i;

	for (i=0;i<2;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(3);											//  VKvbgʒuƂɉߋ̂Q񕪂킹ĂR񕪃NA
	}
}


//============================================================================
//	Plot X ʒűCOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Tempclear(int plotx)
{
	int	i;

	for (i=2;i<4;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(3);											//  VKvbgʒuƂɉߋ̂Q񕪂킹ĂR񕪃NA
	}
}


//============================================================================
//	Plot X ʒu̎xOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Rhumclear(int plotx)
{
	int	i;

	for (i=4;i<6;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(3);											//  VKvbgʒuƂɉߋ̂Q񕪂킹ĂR񕪃NA
	}
}



//============================================================================
//	C𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_press(int pdata)
{
	/*@\̈NA */
	LCD_locate(0,0);
	LCD_clear(5 * 6);

	print_num(pdata,4,0);
}


//============================================================================
//	x𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_temp(int tempA, int temp_sign)
{
	int col;
	int r;
	unsigned char *pc;

	/*@\̈NA */
	LCD_locate(0,2);
	LCD_clear(5 * 6);

	/* \ */
	LCD_locate(0, 2);
	if (temp_sign != 0) {
		pc = (unsigned char *)font_minus;
	} else {
		pc = (unsigned char *)font_plus;
	}
	LCD_set_data(pc, 5);

	/* x̐l\ij */
	print_num(tempA/10, 2, 2);

	/* _\@*/
	col = 3;
	LCD_locate(col*6, 2);
	pc = (unsigned char *)font_period;
	LCD_set_data(pc, 5);

	/* x̐l\ij */
	tempA = tempA % 10;
	print_num(tempA, 4, 2);

}

//============================================================================
//	Ύx𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_RH(int RHA)
{
	int col;
	int r;
	unsigned char *pc;

	/*@\̈NA */
	LCD_locate(0,4);
	LCD_clear(5 * 6);

	/* x̐l\ij */
	print_num(RHA/10, 2, 4);

	/* _\@*/
	col = 3;
	LCD_locate(col*6, 4);
	pc = (unsigned char *)font_period;
	LCD_set_data(pc, 5);

	/* x̐l\ij */
	RHA = RHA % 10;
	print_num(RHA, 4, 4);

}

//============================================================================
//	mLA5110LCD֋Cf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int pdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//============================================================================
void print_Presgraph(int plotx, UH pdata)
{
	int	 pgraphy;

	if (pdata < 2000 ) {

		graph_plotx_Presclear(plotx);

		pgraphy = pdata - LCD_MIN_PRES + 32;

		draw_Prespoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, pgraphy);

	}
}

//============================================================================
//	mLA5110LCD։xf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int tdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//============================================================================
void print_Tempgraph(int plotx, int tdata)
{
	int	 tgraphy;

	graph_plotx_Tempclear(plotx);

	tgraphy = (tdata * 16 / LCD_MAX_TEMP) + 16;

	draw_Temppoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, tgraphy);
}

//============================================================================
//	mLA5110LCD֎xf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int rhdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//============================================================================
void print_Rhumgraph(int plotx, int rhdata)
{
	int	 rhgraphy;

	graph_plotx_Rhumclear(plotx);

	rhgraphy = rhdata * 16 / 100;

	draw_Rhumpoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, rhgraphy);
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************
